"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const melonjs_1 = require("@melonproject/melonjs");
exports.accounting = ([_, routes], __, context) => {
    if (routes.accounting && !melonjs_1.isZeroAddress(routes.accounting)) {
        return new melonjs_1.Accounting(context.environment, routes.accounting);
    }
    return null;
};
exports.feeManager = ([_, routes], __, context) => {
    if (routes.feeManager && !melonjs_1.isZeroAddress(routes.feeManager)) {
        return routes.feeManager && new melonjs_1.FeeManager(context.environment, routes.feeManager);
    }
    return null;
};
exports.participation = ([_, routes], __, context) => {
    if (routes.participation && !melonjs_1.isZeroAddress(routes.participation)) {
        return routes.participation && new melonjs_1.Participation(context.environment, routes.participation);
    }
    return null;
};
exports.policyManager = ([_, routes], __, context) => {
    if (routes.policyManager && !melonjs_1.isZeroAddress(routes.policyManager)) {
        return routes.policyManager && new melonjs_1.PolicyManager(context.environment, routes.policyManager);
    }
    return null;
};
exports.shares = ([_, routes], __, context) => {
    if (routes.shares && !melonjs_1.isZeroAddress(routes.shares)) {
        return routes.shares && new melonjs_1.Shares(context.environment, routes.shares);
    }
    return null;
};
exports.trading = ([_, routes], __, context) => {
    if (routes.accounting && !melonjs_1.isZeroAddress(routes.accounting)) {
        return routes.trading && [routes, new melonjs_1.Trading(context.environment, routes.trading)];
    }
    return null;
};
exports.vault = ([_, routes], __, context) => {
    if (routes.vault && !melonjs_1.isZeroAddress(routes.vault)) {
        return routes.vault && new melonjs_1.Vault(context.environment, routes.vault);
    }
    return null;
};
exports.priceSource = ([_, routes], __, context) => {
    if (routes.priceSource && !melonjs_1.isZeroAddress(routes.priceSource)) {
        return routes.priceSource && new melonjs_1.PriceSourceInterface(context.environment, routes.priceSource);
    }
    return null;
};
exports.registry = ([_, routes], __, context) => {
    if (routes.registry && !melonjs_1.isZeroAddress(routes.registry)) {
        return routes.registry && new melonjs_1.Registry(context.environment, routes.registry);
    }
    return null;
};
exports.version = ([_, routes], __, context) => {
    if (routes.version && !melonjs_1.isZeroAddress(routes.version)) {
        return routes.version && new melonjs_1.Version(context.environment, routes.version);
    }
    return null;
};
exports.engine = ([_, routes], __, context) => {
    if (routes.engine && !melonjs_1.isZeroAddress(routes.engine)) {
        return routes.engine && new melonjs_1.Engine(context.environment, routes.engine);
    }
    return null;
};
